package com.maroontress.sanctuary;

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   ͤηǤ

   returnǤбޤ
*/
public class Return {

    /** type° */
    private String type;

    /** descǤ */
    private Description desc;

    /**
       ͤηޤ

       @param g 롼
       @param nodes return
    */
    public Return(final Group g, final NodeList nodes) {
	type = "void";

	if (nodes == null || nodes.getLength() == 0) {
	    return;
	}
	Element elem = (Element) nodes.item(0);
	type = g.expandAT(elem, "type");
	g.importTags(type);

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       ɤǽϤͤηɽ¦ʸޤ

       @return ͤηɽ¦ʸ
    */
    public String getLeftCode() {
	int k = CommentedString.indexOf(type, '#');
	if (k == -1) {
	    return type + " ";
	}
	return type.substring(0, k);
    }

    /**
       ɤǽϤͤηɽ¦ʸޤ

       @return ͤηɽ¦ʸ
    */
    public String getRightCode() {
	int k = CommentedString.indexOf(type, '#');
	if (k == -1) {
	    return "";
	}
	return type.substring(k + 1);
    }

    /**
       HTMLǽϤͤηɽʸޤ

       @param g ͤ°륰롼
       @return ͤηɽʸ
    */
    public String getHTML(final Group g) {
	int k = CommentedString.indexOf(type, '#');
	if (k != -1) {
	    return g.getHTML(type.substring(0, k) + type.substring(k + 1));
	} else {
	    return g.getHTML(type);
	}
    }

    /**
       TeXǽϤͤηɽʸޤ

       @param g ͤ°륰롼
       @return ͤηɽʸ
    */
    public String getTEX(final Group g) {
	int k = CommentedString.indexOf(type, '#');
	if (k != -1) {
	    return g.getTEX(type.substring(0, k) + type.substring(k + 1));
	} else {
	    return g.getTEX(type);
	}
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	if (desc == null) {
	    return;
	}
	wr.println(""
+ "<dl>Returns:<dd>" + desc.getText() + "</dd></dl>");
   }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	if (desc == null) {
	    return;
	}
	wr.println("\\Sreturn");
	wr.println("\\begin{Sindentation}{\\Sindentlength}{0pt}");
	wr.println(desc.getTexText());
	wr.println("\\end{Sindentation}");
    }
}
